﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetDepartments();
            WebDataGrid1.DataSource = Session["GridData"];

            CreateColumns();

            TemplateDataField templateColumn1 = (TemplateDataField)this.WebDataGrid1.Columns["TemplateField1"];
            templateColumn1.ItemTemplate = new CustomItemTemplate();
            templateColumn1.FooterTemplate = new CustomItemTemplate();

            WebDataGrid1.DataBind();
        }
        else
        {
            WebDataGrid1.DataSource = Session["GridData"];

            TemplateDataField templateColumn1 = (TemplateDataField)this.WebDataGrid1.Columns["TemplateField1"];
            templateColumn1.ItemTemplate = new CustomItemTemplate();
            templateColumn1.FooterTemplate = new CustomItemTemplate();
        }

        Image img = (Image)WebDataGrid1.Rows[0].Items[3].FindControl("IconImage");
    }

    private void CreateColumns()
    {
        BoundDataField boundField = new BoundDataField(true);
        boundField.Key = "DepartmentID";
        boundField.DataFieldName = "DepartmentID";
        boundField.Header.Text = "Dept. ID";
        //boundField.Footer.TemplateId = "template1";
        //boundField.Header.TemplateId = "Template1";

        WebDataGrid1.Columns.Add(boundField);

        boundField = new BoundDataField(true);
        boundField.Key = "DepartmentName";
        boundField.DataFieldName = "DepartmentName";
        boundField.Header.Text = "Dept. Name";

        WebDataGrid1.Columns.Add(boundField);

        boundField = new BoundDataField(true);
        boundField.Key = "Image2";
        boundField.DataFieldName = "Image2";
        boundField.Header.Text = "Image2";
        boundField.HtmlEncode = false;
        boundField.DataFormatString = "<img alt='' src='{0}.gif' />";

        WebDataGrid1.Columns.Add(boundField);

        TemplateDataField templateField = new TemplateDataField(true);
        templateField.Key = "TemplateField1";
        templateField.Header.Text = "Image";

        WebDataGrid1.Columns.Add(templateField);
    }

    private DataTable GetDepartments()
    {
        DataTable dt = new DataTable("Departments");
        dt.Columns.Add("DepartmentID", typeof(int));
        dt.Columns.Add("DepartmentName", typeof(string));
        dt.Columns.Add("Image2", typeof(string));

        for (int i = 0; i < 8; i++)
        {
            dt.Rows.Add(new object[] { i, string.Format("Department {0}", i), "add_up" });
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns["DepartmentID"] };

        return dt;
    }

    private class CustomItemTemplate : ITemplate
    {
        #region ITemplate Members

        public void InstantiateIn(Control container)
        {

            System.Web.UI.WebControls.Image image = new System.Web.UI.WebControls.Image();
            image.ID = "IconImage";
            image.ImageUrl = "add_up.gif";
            container.Controls.Add(image);
        }

        #endregion
    }

}